# -*- coding: utf-8 -*-
"""linear_regression_gradient_shared.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/1sVmg7pLaVN4FLwMTjtcBs4_PzSpI3DyR
"""

import urllib.request
urllib.request.urlretrieve("https://itjaeneungnanum.org/data/travel2003_2019.csv", filename="travel2003_2019.csv")

import os
HOME = os.getcwd()
print(HOME)

# Import libraries
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd

# Load data from .csv
df_data = pd.read_csv("./travel2003_2019.csv", sep=",")
display(df_data)

# Import libraries
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd

# Load data from .csv
df_data = pd.read_csv("./drive/MyDrive/09.work/003.linear_regression/travel2003_2019.csv", sep=",")

# Used features and target value
features = ["Gross_National_Income_per_capita"]
target = ["traveler"]

# Slice Dataframe to separade feature vectors and target value
X, y = df_data[features].to_numpy(), df_data[target].to_numpy()

X = X / 1000
y = y / 1000000
plt.scatter(X, y)
plt.show()

def mse(predictions, targets):
    # Retrieving number of samples in dataset
    samples_num = len(predictions)

    # Summing square differences between predicted and expected values
    accumulated_error = 0.0
    for prediction, target in zip(predictions, targets):
        accumulated_error += (prediction - target)**2

    # Calculating mean and dividing by 2
    mse_error = (1.0 / (2*samples_num)) * accumulated_error

    return mse_error

def predict(x, parameters):
    # Prediction initial value
    prediction = 0

    # Adding multiplication of each feature with it's weight
    for weight, feature in zip(parameters["w"], x):
        prediction += weight * feature

    # Adding bias
    prediction += parameters["b"]

    return prediction

W_list = np.linspace(-3, 4, 100)
J_list = []

for i in range(0, len(W_list)):
    parameters_set = {'b': 0, 'w': np.array([W_list[i]])}
    predict_result = [predict(x, parameters_set) for x in X]
    J_list.append(mse(predict_result, y))

plt.plot(W_list,J_list, 'r')
plt.show()

def train(X, y, model_parameters, learning_rate=0.0005, iterations=20000):
    # Make prediction for every data sample
    predictions = [predict(x, model_parameters) for x in X]

    # Calculate initial cost for model - MSE
    initial_error = mse(predictions, y)

    print("Initial state:")
    print(" - error: {}".format(initial_error))
    print(" - parameters: {}".format(model_parameters))

    for i in range(iterations):
        # Sum up partial gradients for every data sample, for every parameter in model
        accumulated_grad_w0 = 0
        accumulated_grad_b = 0
        for x, y_target in zip(X, y):
            accumulated_grad_w0 += (predict(x, model_parameters) - y_target)*x[0]
            accumulated_grad_b += (predict(x, model_parameters) - y_target)

        # Calculate mean of gradient
        w_grad = (1.0/len(X)) * accumulated_grad_w0
        b_grad = (1.0/len(X)) * accumulated_grad_b

        # Update parameters by small part of averaged gradient
        model_parameters["w"][0] = model_parameters["w"][0] - learning_rate * w_grad
        model_parameters["b"] = model_parameters["b"] - learning_rate * b_grad

        if i % 4000 == 0:
            print("\nIteration {}:".format(i))
            print(" - error: {}".format(mse([predict(x, model_parameters) for x in X], y)))
            print(" - parameters: {}".format(model_parameters))

    print("\nFinal state:")
    print(" - error: {}".format(mse([predict(x, model_parameters) for x in X], y)))
    print(" - parameters: {}".format(model_parameters))

# Load data from .csv
df_data = pd.read_csv("./drive/MyDrive/09.work/003.linear_regression/travel2003_2019.csv", sep=",")

# Used features and target value
features = ["Gross_National_Income_per_capita"]
target = ["traveler"]

# Slice Dataframe to separade feature vectors and target value
X, y = df_data[features].to_numpy(), df_data[target].to_numpy()
X = X / 1000
y = y / 1000

# Init model parameters with zeros
n = len(features)
#model_parameters = init(n)
model_parameters = {'b': 0, 'w': np.array([W_list[0]])}

# Train model
train(X, y, model_parameters)

# Load data from .csv
df_data = pd.read_csv("./drive/MyDrive/09.work/003.linear_regression/travel2003_2019.csv", sep=",")

# Used features and target value
features = ["Gross_National_Income_per_capita"]
target = ["traveler"]

# Slice Dataframe to separade feature vectors and target value
X, y = df_data[features].to_numpy(), df_data[target].to_numpy()

X = X / 1000
y = y / 1000
plt.scatter(X, y)

w_trained = 828.41897152
b_trained = -4502.23684988

pred_y = w_trained * X + b_trained
plt.plot(X, pred_y, color='red')